<?php
 
namespace app\admin\controller;
use think\facade\Db;
include './addons/auto/func.php';
class Auto extends \app\admin\controller\Admin
{
    // 初始化
    public function initialize()
    {
        
        $pre = config("database.connections.mysql.prefix");
        $tableName = $pre . "autolog";
        $req = include './addons/auto/lib/extra/autoconf.php'; 
            $requesturl =$req['url']; 
            require('./addons/auto/config/config.php');
            $tok = $rq['Auto']['token'];
            $sitename=config('site.site_name');
            $hosts=$GLOBALS['_SERVER']['HTTP_HOST'];
            $scheme=$GLOBALS['_SERVER']['REQUEST_SCHEME']; 
            $get='&sitename='.$hosts.'&serverip='.$GLOBALS['_SERVER']['SERVER_ADDR'].'&msgname=&seoname='.$sitename.'&msg=&vod=&img=1&api=1&update=&play=1&uri=&from=&auto=&token='.$tok.'&apiinfo=&type=zanpiancmsv10&http='.$scheme; 
            zanpian_curl($method='GET',$requesturl . '/?msg.html'.$get);
        $isTable = Db::query('SHOW TABLES LIKE ' . "'" . $tableName . "'");
        if (!$isTable) {
            $sql = "CREATE TABLE `{$tableName}` (
                  `id` int(11) NOT NULL AUTO_INCREMENT,
                  `name` varchar(64) DEFAULT NULL COMMENT '资源站名称',
                  `old` varchar(150) DEFAULT NULL COMMENT '老域名',
                  `new` varchar(150) DEFAULT NULL COMMENT '新域名',
                  `type` varchar(32) DEFAULT NULL COMMENT '类型',
                  `runtime` datetime DEFAULT NULL COMMENT '运行时间',
                  `updatesql` longtext NOT NULL,
                  PRIMARY KEY (`id`),
                 KEY `old` (`old`,`new`,`type`),
                 KEY `runtime` (`runtime`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
            $zxjg = Db::query($sql); 
            
            $sqlrout="INSERT INTO ".$pre."menu (menu_pid, menu_module, menu_controller_name, menu_title, menu_pk_id, menu_table_name, menu_is_create, menu_table_status, menu_is_url, menu_is_config, menu_url, menu_icon, menu_tab_menu, menu_app_id, menu_is_submit, menu_upload_config_id, menu_isdev, menu_sort, menu_note, menu_is_menu, menu_system, menu_model_name, menu_status) VALUES ('0', 'auto', '', '牛牛助手', '', '', '0', '0', '0', '0', 'admin/auto/index', 'icon zp-icon zp-icon-vipcard', '', '1', '0', '0', '0', '0', '', '1', '0', '14', '1')";
            Db::query($sqlrout); 
            
        } else {
            return 0;
        }
    }
    // 首页
    public function index()
    { 
        $param = input();
        $this->initialize(); //初始化创建数据库 
        $req = include './addons/auto/lib/extra/autoconf.php'; 
        $requesturl =$req['url']; 
        $res = https_request($requesturl . '/?api.html', '', '', 1500, 3);
        $arrres = auto_json_decode($res);
        $imglist = $arrres['imglist'];
        $apilist = $arrres['apilist'];
        $replist = $arrres['replist'];
        $v10list = $arrres['v10list']; 
        require('./addons/auto/config/config.php');
        $versions = $arrres['code'];
        $not = $arrres['info']; 
        $hostversion = $req['version'];
        $this->assign("hostversion",$hostversion);
        $this->assign("versions",$versions); 
        $this->assign( "rq",$rq);
        $this->assign( "not",$not);
        $this->assign( $req);
        $this->assign("apilist", $apilist);
        $this->assign("replist", $replist);
        $this->assign($v10list);
        $this->assign("imglist", $imglist); 
        return $this->fetch("", array(), array("</body>" => config("zanpian.zanpian_body") . "</body>"));
        
    }
    public function update()
    {
        $param = input(); 
        $v = $param['to']; 
        $req = include './addons/auto/lib/extra/autoconf.php'; 
        $requesturl =$req['url']; 
        $rq = $requesturl.'/update/zpv10/'; 
        echo "<div class='update'><h1>在线升级中,请稍后......</h1><textarea rows=\"10\" class='layui-textarea' readonly>正在下载升级文件包...\n";
        ob_flush();
        flush();
        sleep(1); 
        $save_path = root_path()  . $v . ".zip";
        print_r($save_path);
        $downurl = $rq . $v . ".zip";
        $zips = https_request($downurl);
        @fwrite(@fopen($save_path, "wb"), $zips);
        if (!is_file($save_path)) {
            echo "下载升级包失败，请重试...\n";
            exit;
        }
        if (filesize($save_path) < 1) {
            @unlink($save_path);
            echo "下载升级包失败，请重试...\n";
            exit;
        }
        echo "下载升级包完毕...\n";
        echo "正在处理升级包的文件...\n";
        ob_flush();
        flush();
        sleep(1);
        if (class_exists("ZipArchive")) {
			$zip = new \ZipArchive();
			if ($zip->open($save_path) !== true) {
				return show_msg("<tr><td>打开压缩包失败</td></tr>");
			}
			if (!$zip->extractTo(root_path())) {
				$zip->close();
				return show_msg("<tr><td>无法提取文件</td></tr>");
			}
			$zip->close();
			show_msg("<tr><td>解压升级包成功</td></tr>");
			@unlink($save_path);
			return root_path();
		}
        echo "更新数据缓存文件...\n";
        echo "插件升级完毕...";
        echo "请及时更新API设置token密钥，以恢复默认";
        ob_flush();
        flush();
        echo "</textarea></div>";
        echo "<script type=\"text/javascript\">layui.use([\"jquery\",\"layer\"],function(){var layer=layui.layer,\$=layui.jquery;setTimeout(function(){var index=parent.layer.getFrameIndex(window.name);parent.location.reload();parent.layer.close(index)},\"6000\")});</script>";
    }
      
}
